#pragma once
#include <FastLED.h>
#include <vector>
#include <list>
#include "edge.h"

class Corner {
	public:
	Edge* e1;
	Edge* e2;
	Corner(Edge* e1, Edge* e2);
	std::list<uint16_t> _leds;
	std::vector<Corner*> _long_neighbours {};
	std::vector<Corner*> _short_neighbours {};
	CRGB color = CRGB(0x000000);
	CRGB source_color;
	CRGB target_color;
	bool effect_running = false;
	uint8_t color_blend_state = 255;
	uint16_t effect_id;
	bool loop();
	void draw();
	void blend_to(CRGB color, uint16_t effect_id=0);
	void add_led(uint16_t led_id);
	void merge_leds(Corner* c);

	private:
	void infect(std::vector<Corner*>* neighbours);
};